#include "pitches.h"
#include <HCSR04.h>
#include <Servo.h>

UltraSonicDistanceSensor distanceSensor(12, 11);
Servo servo;

const int BUTTON_PIN = 7;
const int SERVO_PIN  = 9;
const int SPEAKER_PIN  = 5;

int Melodia[] = {NOTE_B4, NOTE_E5, NOTE_E5, NOTE_E5, NOTE_D5, NOTE_E5, NOTE_E5, NOTE_B4, NOTE_B4, NOTE_D5};
int DuracionNotas[] = {4, 4, 2, 2, 2, 4, 4, 4, 4, 4};
int lastDistance;
int lastButtonState;
int currentButtonState;

void setup() {
  pinMode(BUTTON_PIN, INPUT_PULLUP);
  pinMode(5, OUTPUT);
  servo.attach(SERVO_PIN);
  servo.write(0); //posicion inicial del servo es 0
  currentButtonState = digitalRead(BUTTON_PIN);
  Serial.begin(9600);
}

void loop() {

  if (digitalRead(BUTTON_PIN) == LOW)
  {
    lookAtWall();
    MelodiaJuego();
    //lookAtPlayers();

    while (1)
    {
      lookAtPlayers();
      delay(1000);
      if (DetectarMovimiento())
      {
        Serial.println("You lose!");
        //player dies
        tone (SPEAKER_PIN, NOTE_C4, 200);
        delay(400);
        tone (SPEAKER_PIN, NOTE_C4, 200);
        delay(400);
        return;
      }
      lookAtWall();
      MelodiaJuego();
      //{
        if (ReadButton())
        {
          //player wins
          return;
        }
      //}
    }

  }
}

boolean DetectarMovimiento() {    //true if movement detected

  int currentDistance = distanceSensor.measureDistanceCm();
  int lastDistance = currentDistance;
  delay (200);
  for (int i = 0; i < 30; i++) {
    currentDistance = distanceSensor.measureDistanceCm();
    Serial.println(currentDistance - lastDistance);
    if (abs(lastDistance - currentDistance) > 3) {
      return true;
    }
    lastDistance = currentDistance;

    delay(100);
  }
  return false;
}

boolean ReadButton()
{
  for (int i = 0; i < 20; i++)
  {
    if (digitalRead(BUTTON_PIN) == LOW)
      return true;

    delay(100);
  }
  return false;
}

void lookAtPlayers()
{
  servo.write(180);
}

void lookAtWall()
{
  servo.write(0);
}

boolean MelodiaJuego() {

  for (int i = 0; i < 10; i++) {
    //if (digitalRead(BUTTON_PIN) == LOW)
      //return true;
    int Duracion = 1000 / DuracionNotas[i];
    tone (SPEAKER_PIN, Melodia[i], Duracion);
    delay (Duracion * 1.2);
    noTone(SPEAKER_PIN);
  }
  return false;
}
